<?php

namespace EventPortal\AuthPassword\Providers;

use Illuminate\Support\ServiceProvider;

class AuthPasswordServiceProvider extends ServiceProvider
{
    /** @var string */
    protected $root = __DIR__ . '/../..';

    /** @var string */
    protected $namespace = 'EventPortal\AuthPassword\Http\Controllers';

    /** @var array<string> */
    protected $tags = [
        'auth-password',
    ];

    public function boot(): void
    {
        $this->loadRoutesFrom("{$this->root}/routes/routes.php");

        $this->loadMigrationsFrom("{$this->root}/database/migrations");

        $this->publishes([
            "{$this->root}./database/migrations" => database_path('migrations'),
        ], $this->tags);

        $this->publishes([
            "{$this->root}/config/auth-password.php" => config_path('auth-password.php'),
        ], $this->tags);

        $this->loadViewsFrom("{$this->root}/views/emails", 'auth-password');

        $this->publishes([
            "{$this->root}/views/emails" => resource_path('views/vendor/event-portal/emails/auth-password'),
        ], $this->tags);
    }

    public function register(): void
    {
        $this->mergeConfigFrom("{$this->root}/config/auth-password.php", 'auth-password');
    }
}
